library(psych)
library(nFactors)

#READ DATA AND REMOVE MISSING VALUES#
library(foreign)
file.choose()
ats.subscales<-read.spss("C:\\research\\sage factor analysis book\\adult temperament scale subscale level.sav",
	to.data.frame=TRUE, use.value.labels=FALSE)
ats.subscales.nomiss<-na.omit(ats.subscales)



#SCREE PLOT#
scree(ats.subscales.nomiss)

#OBJECTIVE METHODS BASED ON SCREE PLOT#
ats.eigenvalues<-eigen(cor(ats.subscales.nomiss))
nMreg(ats.subscales.nomiss, model="factors")
nCng(ats.subscales.nomiss, model="factors")
plotnScree(nScree(ats.eigenvalues$values, model="factors"))

#PARALLEL ANALYSIS#
ats.pa<-fa.parallel(ats.subscales.nomiss, fm="pa", n.iter=1000, error.bars=FALSE, SMC=FALSE)

#CDM#
EFA.Comp.Data(ats.subscales.nomiss, F.Max=10, N.Pop=10000, N.Samples=500, Alpha=0.30, Graph=F, Spearman=F)

#EIGENVALUES#
ats.pa$fa.values

#MAP#
ats.vss<-vss(ats.subscales.nomiss, n=13, rotate="promax", diagonal=FALSE, fm="pa", plot=TRUE, SMC=FALSE)
ats.vss$map

#VERY SIMPLE STRUCTURE#
plot(motivation.vss)



#FACTOR EXTRACTION AND ROTATION#
#PRINCIPAL AXIS FACTORING WITH PROMAX ROTATION#
ats.4factor<-fa(ats.subscales.nomiss, nfactors=4, rotate="promax", SMC=TRUE, fm="pa")
ats.5factor<-fa(ats.subscales.nomiss, nfactors=5, rotate="promax", SMC=TRUE, fm="pa")
anova(ats.4factor, ats.5factor)


#TARGET ROTATION#
 Targ2 <- make.keys(13,list(f1=1:4,f2=5:7, f3=8:10, f4=11:13)) 
 Targ2 <- scrub(Targ2,isvalue=1)  #fix the 0s, allow the NAs to be estimated
 Targ2 <- list(Targ2)  #input must be a list
#show the target
 Targ2
fa(ats.subscales,4,rotate="TargetQ",Target=Targ2)  #targeted rotation

#BIFACTOR ROTATION#
fa(ats.subscales,4,rotate="biquartimin")
